using System;

namespace Netron.GraphLib.IO.NML
{
	/// <summary>
	/// Generic Collection of NML related data
	/// </summary>
	public class DataCollection : System.Collections.CollectionBase 
	{
            
		
		#region Constructor
		/// <summary>
		/// Default constructor
		/// </summary>
		public DataCollection() 
		{
		}
        
		#endregion
		
		#region Methods
		/// <summary>
		/// Integer indexer
		/// </summary>
		public virtual object this[int index] 
		{
			get 
			{
				return this.List[index];
			}
			set 
			{
				this.List[index] = value;
			}
		}
            
		
		/// <summary>
		/// Adds an item to the collection
		/// </summary>
		/// <param name="o"></param>
		public virtual void Add(object o) 
		{
			this.List.Add(o);
		}
            
		/// <summary>
		/// Returns whether the given object is in the collection
		/// </summary>
		/// <param name="o"></param>
		/// <returns></returns>
		public virtual bool Contains(object o) 
		{
			return this.List.Contains(o);
		}
            
		/// <summary>
		/// Remove an item from the collection
		/// </summary>
		/// <param name="o"></param>		
		public virtual void Remove(object o) 
		{
			this.List.Remove(o);
		}
		
		/// <summary>
		/// Overrides the default method to return
		/// the content of the collection
		/// </summary>
		/// <returns></returns>
		public override string ToString() 
		{
			System.IO.StringWriter sw = new System.IO.StringWriter();
			// <foreach>
			// This loop mimics a foreach call. See C# programming language, pg 247
			// Here, the enumerator is seale and does not implement IDisposable
			System.Collections.IEnumerator enumerator = this.List.GetEnumerator();
			for (
				; enumerator.MoveNext(); 
				) 
			{
				string s = ((string)(enumerator.Current));
				// foreach body
				sw.Write(s);
			}
			// </foreach>
			return sw.ToString();
		}

		#endregion
	}
}
